#ifndef NPCS_HPP_INCLUDED
#define NPCS_HPP_INCLUDED

#include "../../Game/Interactable/NPC.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

namespace NPCs
{
    std::vector<Interactable::NPC> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::NPC> GetAll();
    std::vector<Interactable::NPC> GetAll(const Tile& T);
    std::vector<Interactable::NPC> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::NPC> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::NPC> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::NPC> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::NPC> GetAll(const std::function<bool (const Interactable::NPC&)>& Filter, std::int32_t Distance = -1);

    Interactable::NPC Get(const Tile& T);
    Interactable::NPC Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::NPC Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::NPC Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::NPC Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::NPC Get(const std::function<bool (const Interactable::NPC&)>& Filter, std::int32_t Distance = -1);
}

#endif // NPCS_HPP_INCLUDED
